/****************************************************************************************************************************
    ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO Raspberry Pi Pico Robot Car lesson 1 : Basic Movement
 * Tutorial link:  https://osoyoo.com/?p=49521
 * CopyRIGHT www.osoyoo.com
*/
/*****************************************************************************************************************************/

#define _PWM_LOGLEVEL_        3
#include "RP2040_PWM.h"

#define IN1      16    // GP16 to IN1 right motor direction pin
#define IN2      17    // GP17 to IN2 right motor direction pin
#define IN3      18    // GP18 to IN3 left motor direction pin
#define IN4      19    // GP19 to IN4 left motor direction pin
#define ENA      9     // GP10 to ENA right motor PWM
#define ENB      10    // GP9  to ENB left motor PWM

RP2040_PWM* PWM_Left;
RP2040_PWM* PWM_Right;

float frequency;
float SPEED=50.f;
float TURN_SPEED=100.f;
void set_speed(float speed_left,float speed_right )
{
  PWM_Left->setPWM(ENB, frequency, speed_left, true);
  PWM_Right->setPWM(ENA, frequency, speed_right, true);
}
void stopcar( )
{
  PWM_Left->setPWM(ENB, frequency, 0, true);
  PWM_Right->setPWM(ENA, frequency, 0, true);
  digitalWrite(IN1,0);
  digitalWrite(IN2,0);
  digitalWrite(IN3,0);
  digitalWrite(IN4,0);
  
}
void  backward()
{
  digitalWrite(IN1,HIGH);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  set_speed(SPEED,SPEED);
}
void forward()
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,HIGH);
  set_speed(SPEED,SPEED);
}
void left_turn()
{
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  set_speed(0,TURN_SPEED);
}
void right_turn()
{
  digitalWrite(IN1,HIGH);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
  set_speed(TURN_SPEED,0);
}
void setup()
{
  pinMode(IN1,OUTPUT);
  pinMode(IN2,OUTPUT);
  pinMode(IN3,OUTPUT);
  pinMode(IN4,OUTPUT);
  frequency = 1000;
  PWM_Left = new RP2040_PWM(ENA, frequency, 50);
  PWM_Right = new RP2040_PWM(ENB,frequency, 50);
  if (PWM_Left)
  {
    PWM_Left->setPWM();
  }
  if (PWM_Right)
  {
    PWM_Right->setPWM();
  }
  forward();
  delay(2000);
  backward();
  delay(2000);
  left_turn();
  delay(2000);
  right_turn();
  delay(2000);
  stopcar();
}

 
void loop()
{
 
 
}
